# Changelog

### 1.4.15

* Fixed regression with multiple constructors introduced in 1.4.10

### 1.4.14

* Moved LocalTimeDecoder to core module

### 1.4.13

* Fixed regression with ConfigSouce::fromPath #234

### 1.4.12

* Added ParameterStorePathPreprocessor
* Added ParameterStorePathPropertySource
* add LocalTimeDecoder (#233) - Jan Brezina

### 1.4.11

* Added order to defaults (Sources, Preprocessors and ParamMappers) (#229) - David Gomes

### 1.4.10

* Added extension methods for Minutes and Seconds to Kotlin durations.
* data class with multiple constructors can select appropriate constructor to load (#231) - alexis-airwallex

### 1.4.9

* Added `Minutes` and `Seconds` as types and added decoders for both.

### 1.4.8

* Added support for watchers via the `hoplite-watch` and `hoplite-watch-consul` modules.
* Added config builder option to not include the default decoders and processors.

### 1.4.7

* Re-added support for Java8

### 1.4.6

* Added [AwsSecretsManagerPreprocessor](https://aws.amazon.com/secrets-manager/) preprocessor.
* Bumped AWS client version to 1.12.36

### 1.4.5

* Added [Consul](https://www.consul.io/) preprocessor.

### 1.4.4

* Adds basic command line property source. (#217)

### 1.4.3

* Arrow moduled upgraded to arrow 0.13.2

### 1.4.2

* Added overload to support config when the config class is not reified. #213

### 1.4.1

* Support for [yaml aliases](https://bitbucket.org/asomov/snakeyaml-engine/wiki/Documentation#markdown-header-aliases) #208.

### 1.4.0

* **Kotlin version is now 1.4.30**
* Breaking: The `PropertySource` interface has been changed to accept a `PropertySourceContext`. This only affects users who have written their own custom PropertySource.
* Added `@ConfigAlias` to allow a data class field to map to multiple values. #197
* Added strict option to `ConfigLoader.Builder` to throw an error if a config value is unused. Lenient mode is still the default. #187
* Bumped all module deps to latest versions

### 1.3.15

* Added support for ISO format in `Instant` decoder #192
* Added suport for objects in sealed classes #194

### 1.3.14

* Added {{style}} syntax for lookups across files.

### 1.3.13

* Fixed value types to allow for underlying types that are not strings. Eg, `data class Weight(val value: Int)`

### 1.3.12

* Allows data classes with a single field named `value` to be treated as inline classes. Eg `data class RetailerId(val value: String)` can be parsed directly from `retailerId: "SAKS"` without requiring another level of nesting #164

### 1.3.11

* Added `hoplite-vavr` module #185
* Added convenience methods to `PropertySource` to read from strings, streams and optional paths #186

### 1.3.10

* Fixed decoding of sets of enums #181

### 1.3.9

* Added `kotlinx-datetime` module #166
* Fix parser registry for custom mappings #179
